# -*- coding: utf-8 -*-

"""
/***************************************************************************
 SEDucate
                                 A QGIS plugin
 Create Sedimentology Log Excerices
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2021-11-03
        copyright            : (C) 2021 by Bjorn Nyberg, Sigrid Næsheim, Henk Keers
        email                : bjorn.nyberg@uib.no
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'Bjorn Nyberg, Sigrid Næsheim, Henk Keers'
__date__ = '2021-11-03'
__copyright__ = '(C) 2021 by Bjorn Nyberg, Lisbeth Vedå, Sigrid Næsheim, Henk Keers'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

from qgis.core import QgsProcessingProvider

from .CreateMapLogs import CreateMapLogs
from .CreatePrintLayout import CreatePrintLayout
from .LoadExample import LoadExample
from .configureSeducate import configureSeducate
from .CreateEnvironment import CreateEnvironment
from .DeleteEnvironment import DeleteEnvironment


class SEDucateProvider(QgsProcessingProvider):

    def __init__(self):
        """
        Default constructor.
        """
        QgsProcessingProvider.__init__(self)

    def unload(self):
        """
        Unloads the provider. Any tear-down steps required by the provider
        should be implemented here.
        """
        pass

    def loadAlgorithms(self):
        """
        Loads all algorithms belonging to this provider.
        """
        self.addAlgorithm(CreateMapLogs())
        self.addAlgorithm(CreatePrintLayout())
        self.addAlgorithm(LoadExample())
        self.addAlgorithm(configureSeducate())
        self.addAlgorithm(CreateEnvironment())
        self.addAlgorithm(DeleteEnvironment())

        # add additional algorithms here
        # self.addAlgorithm(MyOtherAlgorithm())

    def id(self):
        """
        Returns the unique provider id, used for identifying the provider. This
        string should be a unique, short, character only string, eg "qgis" or
        "gdal". This string should not be localised.
        """
        return 'Tools'

    def name(self):
        """
        Returns the provider name, which is used to describe the provider
        within the GUI.

        This string should be short (e.g. "Lastools") and localised.
        """
        return self.tr('SEDucate')

    def icon(self):
        """
        Should return a QIcon which is used for your provider inside
        the Processing toolbox.
        """
        return QgsProcessingProvider.icon(self)

    def longName(self):
        """
        Returns the a longer version of the provider name, which can include
        extra details such as version numbers. E.g. "Lastools LIDAR tools
        (version 2.2.1)". This string should be localised. The default
        implementation returns the same string as name().
        """
        return self.name()
